#define ENTITY 2
#define PERM  4
#define DELIM 8
#define END 16

static char charmap[256] = {
    END,           /*    0 0x00 '\x00' */
    0,             /*    1 0x01 '\x01' */
    0,             /*    2 0x02 '\x02' */
    0,             /*    3 0x03 '\x03' */
    0,             /*    4 0x04 '\x04' */
    0,             /*    5 0x05 '\x05' */
    0,             /*    6 0x06 '\x06' */
    0,             /*    7 0x07 '\x07' */
    0,             /*    8 0x08 '\x08' */
    DELIM,         /*    9 0x09 '\t'   */
    DELIM,         /*   10 0x0a '\n'   */
    0,             /*   11 0x0b '\x0b' */
    0,             /*   12 0x0c '\x0c' */
    DELIM,         /*   13 0x0d '\r'   */
    0,             /*   14 0x0e '\x0e' */
    0,             /*   15 0x0f '\x0f' */
    0,             /*   16 0x10 '\x10' */
    0,             /*   17 0x11 '\x11' */
    0,             /*   18 0x12 '\x12' */
    0,             /*   19 0x13 '\x13' */
    0,             /*   20 0x14 '\x14' */
    0,             /*   21 0x15 '\x15' */
    0,             /*   22 0x16 '\x16' */
    0,             /*   23 0x17 '\x17' */
    0,             /*   24 0x18 '\x18' */
    0,             /*   25 0x19 '\x19' */
    0,             /*   26 0x1a '\x1a' */
    0,             /*   27 0x1b '\x1b' */
    0,             /*   28 0x1c '\x1c' */
    0,             /*   29 0x1d '\x1d' */
    0,             /*   30 0x1e '\x1e' */
    0,             /*   31 0x1f '\x1f' */
    DELIM,         /*   32 0x20 ' '    */
    ENTITY,        /*   33 0x21 '!'    */
    ENTITY,        /*   34 0x22 '"'    */
    ENTITY,        /*   35 0x23 '#'    */
    ENTITY,        /*   36 0x24 '$'    */
    ENTITY,        /*   37 0x25 '%'    */
    ENTITY,        /*   38 0x26 '&'    */
    ENTITY,        /*   39 0x27 "'"    */
    ENTITY,        /*   40 0x28 '('    */
    ENTITY,        /*   41 0x29 ')'    */
    ENTITY,        /*   42 0x2a '*'    */
    ENTITY,        /*   43 0x2b '+'    */
    ENTITY,        /*   44 0x2c ','    */
    ENTITY,        /*   45 0x2d '-'    */
    ENTITY,        /*   46 0x2e '.'    */
    ENTITY,        /*   47 0x2f '/'    */
    ENTITY,        /*   48 0x30 '0'    */
    ENTITY,        /*   49 0x31 '1'    */
    ENTITY,        /*   50 0x32 '2'    */
    ENTITY,        /*   51 0x33 '3'    */
    ENTITY,        /*   52 0x34 '4'    */
    ENTITY,        /*   53 0x35 '5'    */
    ENTITY,        /*   54 0x36 '6'    */
    ENTITY,        /*   55 0x37 '7'    */
    ENTITY,        /*   56 0x38 '8'    */
    ENTITY,        /*   57 0x39 '9'    */
    0,             /*   58 0x3a ':'    */
    ENTITY,        /*   59 0x3b ';'    */
    ENTITY,        /*   60 0x3c '<'    */
    ENTITY,        /*   61 0x3d '='    */
    ENTITY,        /*   62 0x3e '>'    */
    ENTITY,        /*   63 0x3f '?'    */
    ENTITY,        /*   64 0x40 '@'    */
    ENTITY | PERM, /*   65 0x41 'A'    */
    ENTITY | PERM, /*   66 0x42 'B'    */
    ENTITY | PERM, /*   67 0x43 'C'    */
    ENTITY | PERM, /*   68 0x44 'D'    */
    ENTITY | PERM, /*   69 0x45 'E'    */
    ENTITY | PERM, /*   70 0x46 'F'    */
    ENTITY | PERM, /*   71 0x47 'G'    */
    ENTITY | PERM, /*   72 0x48 'H'    */
    ENTITY | PERM, /*   73 0x49 'I'    */
    ENTITY | PERM, /*   74 0x4a 'J'    */
    ENTITY | PERM, /*   75 0x4b 'K'    */
    ENTITY | PERM, /*   76 0x4c 'L'    */
    ENTITY | PERM, /*   77 0x4d 'M'    */
    ENTITY | PERM, /*   78 0x4e 'N'    */
    ENTITY | PERM, /*   79 0x4f 'O'    */
    ENTITY | PERM, /*   80 0x50 'P'    */
    ENTITY | PERM, /*   81 0x51 'Q'    */
    ENTITY | PERM, /*   82 0x52 'R'    */
    ENTITY | PERM, /*   83 0x53 'S'    */
    ENTITY | PERM, /*   84 0x54 'T'    */
    ENTITY | PERM, /*   85 0x55 'U'    */
    ENTITY | PERM, /*   86 0x56 'V'    */
    ENTITY | PERM, /*   87 0x57 'W'    */
    ENTITY | PERM, /*   88 0x58 'X'    */
    ENTITY | PERM, /*   89 0x59 'Y'    */
    ENTITY | PERM, /*   90 0x5a 'Z'    */
    ENTITY,        /*   91 0x5b '['    */
    ENTITY,        /*   92 0x5c '\\'   */
    ENTITY,        /*   93 0x5d ']'    */
    ENTITY,        /*   94 0x5e '^'    */
    ENTITY,        /*   95 0x5f '_'    */
    0,             /*   96 0x60 '`'    */
    ENTITY | PERM, /*   97 0x61 'a'    */
    ENTITY | PERM, /*   98 0x62 'b'    */
    ENTITY | PERM, /*   99 0x63 'c'    */
    ENTITY | PERM, /*  100 0x64 'd'    */
    ENTITY | PERM, /*  101 0x65 'e'    */
    ENTITY | PERM, /*  102 0x66 'f'    */
    ENTITY | PERM, /*  103 0x67 'g'    */
    ENTITY | PERM, /*  104 0x68 'h'    */
    ENTITY | PERM, /*  105 0x69 'i'    */
    ENTITY | PERM, /*  106 0x6a 'j'    */
    ENTITY | PERM, /*  107 0x6b 'k'    */
    ENTITY | PERM, /*  108 0x6c 'l'    */
    ENTITY | PERM, /*  109 0x6d 'm'    */
    ENTITY | PERM, /*  110 0x6e 'n'    */
    ENTITY | PERM, /*  111 0x6f 'o'    */
    ENTITY | PERM, /*  112 0x70 'p'    */
    ENTITY | PERM, /*  113 0x71 'q'    */
    ENTITY | PERM, /*  114 0x72 'r'    */
    ENTITY | PERM, /*  115 0x73 's'    */
    ENTITY | PERM, /*  116 0x74 't'    */
    ENTITY | PERM, /*  117 0x75 'u'    */
    ENTITY | PERM, /*  118 0x76 'v'    */
    ENTITY | PERM, /*  119 0x77 'w'    */
    ENTITY | PERM, /*  120 0x78 'x'    */
    ENTITY | PERM, /*  121 0x79 'y'    */
    ENTITY | PERM, /*  122 0x7a 'z'    */
    ENTITY,        /*  123 0x7b '{'    */
    ENTITY,        /*  124 0x7c '|'    */
    ENTITY,        /*  125 0x7d '}'    */
    ENTITY,        /*  126 0x7e '~'    */
    0,             /*  127 0x7f '\x7f' */
    0,             /*  128 0x80 '\x80' */
    0,             /*  129 0x81 '\x81' */
    0,             /*  130 0x82 '\x82' */
    0,             /*  131 0x83 '\x83' */
    0,             /*  132 0x84 '\x84' */
    0,             /*  133 0x85 '\x85' */
    0,             /*  134 0x86 '\x86' */
    0,             /*  135 0x87 '\x87' */
    0,             /*  136 0x88 '\x88' */
    0,             /*  137 0x89 '\x89' */
    0,             /*  138 0x8a '\x8a' */
    0,             /*  139 0x8b '\x8b' */
    0,             /*  140 0x8c '\x8c' */
    0,             /*  141 0x8d '\x8d' */
    0,             /*  142 0x8e '\x8e' */
    0,             /*  143 0x8f '\x8f' */
    0,             /*  144 0x90 '\x90' */
    0,             /*  145 0x91 '\x91' */
    0,             /*  146 0x92 '\x92' */
    0,             /*  147 0x93 '\x93' */
    0,             /*  148 0x94 '\x94' */
    0,             /*  149 0x95 '\x95' */
    0,             /*  150 0x96 '\x96' */
    0,             /*  151 0x97 '\x97' */
    0,             /*  152 0x98 '\x98' */
    0,             /*  153 0x99 '\x99' */
    0,             /*  154 0x9a '\x9a' */
    0,             /*  155 0x9b '\x9b' */
    0,             /*  156 0x9c '\x9c' */
    0,             /*  157 0x9d '\x9d' */
    0,             /*  158 0x9e '\x9e' */
    0,             /*  159 0x9f '\x9f' */
    0,             /*  160 0xa0 '\xa0' */
    0,             /*  161 0xa1 '\xa1' */
    0,             /*  162 0xa2 '\xa2' */
    0,             /*  163 0xa3 '\xa3' */
    0,             /*  164 0xa4 '\xa4' */
    0,             /*  165 0xa5 '\xa5' */
    0,             /*  166 0xa6 '\xa6' */
    0,             /*  167 0xa7 '\xa7' */
    0,             /*  168 0xa8 '\xa8' */
    0,             /*  169 0xa9 '\xa9' */
    0,             /*  170 0xaa '\xaa' */
    0,             /*  171 0xab '\xab' */
    0,             /*  172 0xac '\xac' */
    0,             /*  173 0xad '\xad' */
    0,             /*  174 0xae '\xae' */
    0,             /*  175 0xaf '\xaf' */
    0,             /*  176 0xb0 '\xb0' */
    0,             /*  177 0xb1 '\xb1' */
    0,             /*  178 0xb2 '\xb2' */
    0,             /*  179 0xb3 '\xb3' */
    0,             /*  180 0xb4 '\xb4' */
    0,             /*  181 0xb5 '\xb5' */
    0,             /*  182 0xb6 '\xb6' */
    0,             /*  183 0xb7 '\xb7' */
    0,             /*  184 0xb8 '\xb8' */
    0,             /*  185 0xb9 '\xb9' */
    0,             /*  186 0xba '\xba' */
    0,             /*  187 0xbb '\xbb' */
    0,             /*  188 0xbc '\xbc' */
    0,             /*  189 0xbd '\xbd' */
    0,             /*  190 0xbe '\xbe' */
    0,             /*  191 0xbf '\xbf' */
    0,             /*  192 0xc0 '\xc0' */
    0,             /*  193 0xc1 '\xc1' */
    0,             /*  194 0xc2 '\xc2' */
    0,             /*  195 0xc3 '\xc3' */
    0,             /*  196 0xc4 '\xc4' */
    0,             /*  197 0xc5 '\xc5' */
    0,             /*  198 0xc6 '\xc6' */
    0,             /*  199 0xc7 '\xc7' */
    0,             /*  200 0xc8 '\xc8' */
    0,             /*  201 0xc9 '\xc9' */
    0,             /*  202 0xca '\xca' */
    0,             /*  203 0xcb '\xcb' */
    0,             /*  204 0xcc '\xcc' */
    0,             /*  205 0xcd '\xcd' */
    0,             /*  206 0xce '\xce' */
    0,             /*  207 0xcf '\xcf' */
    0,             /*  208 0xd0 '\xd0' */
    0,             /*  209 0xd1 '\xd1' */
    0,             /*  210 0xd2 '\xd2' */
    0,             /*  211 0xd3 '\xd3' */
    0,             /*  212 0xd4 '\xd4' */
    0,             /*  213 0xd5 '\xd5' */
    0,             /*  214 0xd6 '\xd6' */
    0,             /*  215 0xd7 '\xd7' */
    0,             /*  216 0xd8 '\xd8' */
    0,             /*  217 0xd9 '\xd9' */
    0,             /*  218 0xda '\xda' */
    0,             /*  219 0xdb '\xdb' */
    0,             /*  220 0xdc '\xdc' */
    0,             /*  221 0xdd '\xdd' */
    0,             /*  222 0xde '\xde' */
    0,             /*  223 0xdf '\xdf' */
    0,             /*  224 0xe0 '\xe0' */
    0,             /*  225 0xe1 '\xe1' */
    0,             /*  226 0xe2 '\xe2' */
    0,             /*  227 0xe3 '\xe3' */
    0,             /*  228 0xe4 '\xe4' */
    0,             /*  229 0xe5 '\xe5' */
    0,             /*  230 0xe6 '\xe6' */
    0,             /*  231 0xe7 '\xe7' */
    0,             /*  232 0xe8 '\xe8' */
    0,             /*  233 0xe9 '\xe9' */
    0,             /*  234 0xea '\xea' */
    0,             /*  235 0xeb '\xeb' */
    0,             /*  236 0xec '\xec' */
    0,             /*  237 0xed '\xed' */
    0,             /*  238 0xee '\xee' */
    0,             /*  239 0xef '\xef' */
    0,             /*  240 0xf0 '\xf0' */
    0,             /*  241 0xf1 '\xf1' */
    0,             /*  242 0xf2 '\xf2' */
    0,             /*  243 0xf3 '\xf3' */
    0,             /*  244 0xf4 '\xf4' */
    0,             /*  245 0xf5 '\xf5' */
    0,             /*  246 0xf6 '\xf6' */
    0,             /*  247 0xf7 '\xf7' */
    0,             /*  248 0xf8 '\xf8' */
    0,             /*  249 0xf9 '\xf9' */
    0,             /*  250 0xfa '\xfa' */
    0,             /*  251 0xfb '\xfb' */
    0,             /*  252 0xfc '\xfc' */
    0,             /*  253 0xfd '\xfd' */
    0,             /*  254 0xfe '\xfe' */
    0,             /*  255 0xff '\xff' */
};
