#include <sys/types.h>

typedef char webacl_kind_t;
#define WEBACL_USER 'u'
#define WEBACL_OWNER 'o'
#define WEBACL_GROUP 'g'
#define WEBACL_AUTH 'a'
#define WEBACL_ANON '*'

typedef char webacl_t;

typedef struct {
    webacl_kind_t   kind;
    webacl_t        *ent;
    size_t          ent_l;
    webacl_t        *perm;
    size_t          perm_l;
} webacl_item_t;

typedef struct {
    webacl_t    *acl;
    webacl_t    *pos;
} webacl_iter_t;


extern int webacl_iter_start(webacl_t *acl, webacl_iter_t *iter);
extern int webacl_iter_next(webacl_iter_t *iter, webacl_item_t* item);
extern void webacl_iter_stop(webacl_iter_t *iter);

extern int webacl_parse(webacl_t *acl, int *len);

extern int webacl_check(webacl_t *acl, char *user, char *groups[], char perm);
extern int webacl_check_ex(
    webacl_t *acl, char *user, char *groups[], char *owner, char perm
);

extern const char *webacl_error(int code);

extern int webacl_escape(const char *src, char *dest, size_t dest_l);
extern int webacl_unescape(const char *src, char *dest, size_t dest_l);
