#!/usr/bin/env python

import os
import sys
from distutils.core import setup
from distutils.extension import Extension

LIB = os.path.abspath(os.path.join(os.path.dirname(sys.argv[0]), 'lib'))

setup(
    name = "webacl",
    version = "0.5",
    description  = "Web ACL",
    author = "Radek Kanovsky",
    author_email = "radekk@dat.cz",
    data_files = [('lib',['lib/webacl.h', 'lib/webacl.c', 'lib/charmap.h'])],
    ext_modules  = [
            Extension(
                "webacl", ["webacl.c", os.path.join(LIB, "webacl.c")],
                include_dirs = [LIB],
            )
        ]
    )
